"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var plugin_node_resolve_1 = __importDefault(require("@rollup/plugin-node-resolve"));
var rollup_plugin_svelte_1 = __importDefault(require("rollup-plugin-svelte"));
var plugin_virtual_1 = __importDefault(require("@rollup/plugin-virtual"));
var rollup_plugin_terser_1 = require("rollup-plugin-terser");
var preprocessReadme_1 = require("./preprocessReadme");
function createConfig(opts) {
    var _a, _b;
    if (!((_a = opts === null || opts === void 0 ? void 0 : opts.pkg) === null || _a === void 0 ? void 0 : _a.name))
        throw Error("Package name is required as \"name\".");
    if (!((_b = opts === null || opts === void 0 ? void 0 : opts.pkg) === null || _b === void 0 ? void 0 : _b.svelte))
        throw Error("Svelte code entry is required as \"svelte\".");
    var rollupOutputOpts = __assign({ format: "iife", name: "app", file: "public/bundle.js" }, (opts.output || {}));
    var svelteOpts = __assign(__assign({}, (opts.svelte || {})), { extensions: [".svelte", ".md"], preprocess: [preprocessReadme_1.preprocessReadme({ name: opts.pkg.name, svelte: opts.pkg.svelte })] });
    var minify = opts.minify === true;
    return {
        watch: { clearScreen: false },
        input: "entry",
        output: rollupOutputOpts,
        // @ts-expect-error
        plugins: [
            plugin_virtual_1["default"]({
                entry: "import App from \"./README.md\";\n                const app = new App({ target: document.body });\n                export default app;"
            }),
            rollup_plugin_svelte_1["default"](svelteOpts),
            plugin_node_resolve_1["default"](),
            minify && rollup_plugin_terser_1.terser(),
        ].filter(Boolean)
    };
}
exports["default"] = createConfig;
